import type { Generic } from 'adopted-style-sheets';
import type { AccessKeyPropType, AdjustHeightPropType, ButtonProps, DisabledPropType, HideLabelPropType, HideMsgPropType, HintPropType, InputTypeOnDefault, LabelWithExpertSlotPropType, MsgPropType, ShortKeyPropType, StencilUnknown, Stringified, TooltipAlignPropType } from '../../../schema';
import { ControlledInputController } from '../../input-adapter-leanup/controller';
import type { Props as AdapterProps } from '../../input-adapter-leanup/types';
import type { Props, Watches } from './types';
type ValueChangeListener = (value: StencilUnknown) => void;
export declare class InputController extends ControlledInputController implements Watches {
    protected readonly component: Generic.Element.Component & Props & AdapterProps;
    private readonly valueChangeListeners;
    constructor(component: Generic.Element.Component & Props, name: string, host?: HTMLElement);
    validateAccessKey(value?: AccessKeyPropType): void;
    validateAdjustHeight(value?: AdjustHeightPropType): void;
    validateDisabled(value?: DisabledPropType): void;
    validateTooltipAlign(value?: TooltipAlignPropType): void;
    validateHideMsg(value?: HideMsgPropType): void;
    validateHideLabel(value?: HideLabelPropType): void;
    validateHint(value?: HintPropType): void;
    validateId(value?: string): void;
    validateLabel(value?: LabelWithExpertSlotPropType): void;
    validateMsg(value?: Stringified<MsgPropType>): void;
    validateOn(value?: InputTypeOnDefault): void;
    validateShortKey(value?: ShortKeyPropType): void;
    validateSmartButton(value?: ButtonProps | string): void;
    validateTabIndex(value?: number): void;
    componentWillLoad(): void;
    private emitEvent;
    protected onBlur(event: Event): void;
    protected onChange(event: Event, value?: StencilUnknown): void;
    protected onInput(event: Event, shouldSetFormAssociatedValue?: boolean, value?: StencilUnknown): void;
    protected onClick(event: Event): void;
    protected onFocus(event: Event): void;
    protected onKeyDown(event: KeyboardEvent): void;
    addValueChangeListener(listener: ValueChangeListener): void;
    readonly onFacade: {
        onBlur: (event: Event) => void;
        onChange: (event: Event, value?: StencilUnknown) => void;
        onClick: (event: Event) => void;
        onFocus: (event: Event) => void;
        onInput: (event: Event, shouldSetFormAssociatedValue?: boolean, value?: StencilUnknown) => void;
        onKeyDown: (event: KeyboardEvent) => void;
    };
    readonly updateCurrentLengthDebounced: import("lodash-es").DebouncedFunc<(length: number) => void>;
    hasSoftCharacterLimit(): boolean;
    hasCounter(): boolean;
}
export {};
